#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>

typedef struct cvor* PCVOR;

typedef struct cvor {
	int podatak;
	PCVOR sledeci;
} CVOR;

void dodajElementNaKrajListe(PCVOR *glava, PCVOR *rep, int broj);
void dodajElementNaPocetakListe(PCVOR *glava, PCVOR *rep, int broj);
void prikazListe(PCVOR glava);
double aritmetickaSredinaListe(PCVOR glava);
int izbacivanjeSaPocetka(PCVOR *glava, PCVOR *rep);
int izbacivanjeSaKraja(PCVOR *glava, PCVOR *rep);
int izbacivanjeZadatogElementa(PCVOR *glava, PCVOR *rep, int zadati);

int main(void) {
	PCVOR glava = NULL;
	PCVOR rep = NULL;

	dodajElementNaPocetakListe(&glava, &rep, 15);
	dodajElementNaPocetakListe(&glava, &rep, 20);
	dodajElementNaPocetakListe(&glava, &rep, 25);
	dodajElementNaPocetakListe(&glava, &rep, 30);

	prikazListe(glava);
	printf("Aritmeticka sredina je %.2lf\n",aritmetickaSredinaListe(glava));

	//izbacivanjeSaPocetka(&glava, &rep);
	izbacivanjeZadatogElementa(&glava, &rep, 25);

	
	prikazListe(glava);

	system("pause");
	return 0;
}

void dodajElementNaKrajListe(PCVOR *glava, PCVOR *rep, int broj) {
	PCVOR novi = malloc(sizeof(CVOR));
	novi->podatak = broj;
	novi->sledeci = NULL;

	if (*glava == NULL) {
		*glava = novi;
		*rep = novi;
	}
	else {
		(*rep)->sledeci = novi;
		*rep = novi;
	}
}

void dodajElementNaPocetakListe(PCVOR *glava, PCVOR *rep, int broj) {
	PCVOR novi = malloc(sizeof(CVOR));
	novi->podatak = broj;
	novi->sledeci = *glava;
	if (*glava == NULL) {
		*glava = novi;
		*rep = novi;
	}
	else {
		*glava = novi;
	}
}

void prikazListe(PCVOR glava) {
	PCVOR tek = glava;
	printf("Elementi liste su:\n");
	while (tek != NULL) {
		printf("%d\t", tek->podatak);
		tek = tek->sledeci;
	}
	printf("\n");
}

double aritmetickaSredinaListe(PCVOR glava) {
	int suma = 0;
	int brojElemenata = 0;
	PCVOR tek = glava;
	while (tek != NULL) {
		brojElemenata++;
		suma = suma + tek->podatak;
		tek = tek->sledeci;
	}
	return (double)suma / (double)brojElemenata;
}

int izbacivanjeSaPocetka(PCVOR *glava, PCVOR *rep) {
	PCVOR tek;
	int izbacen;
	if (*glava == NULL) {
		printf("Lista je prazna!!!\n");
		return -999;
	}
	tek = *glava;
	if (*glava == *rep) {
		*glava = NULL;
		*rep = NULL;
	}
	else {
		*glava = (*glava)->sledeci;
	}
	izbacen = tek->podatak;
	free(tek);
	tek = NULL;
	return izbacen;
}

int izbacivanjeSaKraja(PCVOR *glava, PCVOR *rep) {
	PCVOR tek;
	PCVOR pom;
	int izbacen;
	if (*glava == NULL) {
		printf("Lista je prazna!!!\n");
		return -999;
	}
	tek = *rep;
	if (*glava == *rep) {
		*glava = NULL;
		*rep = NULL;
	}
	else {
		pom = *glava;
		while (pom->sledeci != *rep) {
			pom = pom->sledeci;
		}
		*rep = pom;
		(*rep)->sledeci = NULL;
	}
	izbacen = tek->podatak;
	free(tek);
	tek = NULL;
	return izbacen;
}

int izbacivanjeZadatogElementa(PCVOR *glava, PCVOR *rep, int zadati) {
	PCVOR prethodni=NULL;
	PCVOR tekuci=*glava;
	int izbacen;
	while (tekuci != NULL && tekuci->podatak != zadati) {
		prethodni = tekuci;
		tekuci = tekuci->sledeci;
	}
	if (tekuci == NULL) {
		printf("Zadati element ne postoji u listi!\n");
		return -999;
	}
	if (tekuci == *glava) {
		izbacivanjeSaPocetka(glava, rep);
	}
	else {
		if (tekuci == *rep) {
			izbacivanjeSaKraja(glava, rep);
		}
		else {
			prethodni->sledeci = tekuci->sledeci;
			izbacen = tekuci->podatak;
			free(tekuci);
			tekuci = NULL;
			return izbacen;
		}
	}

}